#include <ESP8266WiFi.h>
#include <WiFiClient.h>
#include <ESP8266WebServer.h>

#define pump 5 
#define valve1 14
#define valve2 12
#define valve3 13
#define valve4 15
#define valve5 16
#define valve6 4

#ifndef APSSID
#define APSSID "ESPap"
#define APPSK  "thereisnospoon"
#endif

/* Set these to your desired credentials. */
const char *ssid = APSSID;
const char *password = APPSK;

ESP8266WebServer server(80);

/* Just a little test message.  Go to http://192.168.4.1 in a web browser
   connected to this access point to see it.
*/
void handleRoot() {
  server.send(200, "text/html", "<h1>You are connected</h1>");
}

void handlePumpOn() {
  digitalWrite(pump, HIGH); 
  server.send(200, "text/html", "Pump is on!");
}
void handlePumpOff() {
  digitalWrite(pump, LOW); 
  server.send(200, "text/html", "Pump is off!");
}

void handleValveFrontOn() {
  digitalWrite(valve1, HIGH); 
  digitalWrite(valve2, HIGH); 
  digitalWrite(valve3, HIGH); 
  server.send(200, "text/html", "Valves Front are ON...");
}

void handleValveFrontOff() {
  digitalWrite(valve1, LOW); 
  digitalWrite(valve2, LOW); 
  digitalWrite(valve3, LOW); 
  server.send(200, "text/html", "Valves Front are off...");
}

void handleValveBackOn() {
  digitalWrite(valve4, HIGH); 
  digitalWrite(valve5, HIGH); 
  digitalWrite(valve6, HIGH); 
  server.send(200, "text/html", "Valves Back are ON...");
}

void handleValveBackOff() {
  digitalWrite(valve4, LOW); 
  digitalWrite(valve5, LOW); 
  digitalWrite(valve6, LOW); 
  server.send(200, "text/html", "Valves Back are off...");
}

void setup() {
  delay(1000);

  pinMode(pump, OUTPUT);
  pinMode(valve1, OUTPUT);
  pinMode(valve2, OUTPUT);
  pinMode(valve3, OUTPUT);
  pinMode(valve4, OUTPUT);
  pinMode(valve5, OUTPUT);
  pinMode(valve6, OUTPUT);
  
  Serial.begin(115200);
  
  Serial.println();
  Serial.print("Configuring access point...");
  /* You can remove the password parameter if you want the AP to be open. */
  WiFi.softAP(ssid, password);

  IPAddress myIP = WiFi.softAPIP();
  Serial.print("AP IP address: ");
  Serial.println(myIP);
  
  server.on("/", handleRoot);
  server.on("/pump/on", handlePumpOn);
  server.on("/pump/off", handlePumpOff);
  server.on("/valveFront/on", handleValveFrontOn);
  server.on("/valveFront/off", handleValveFrontOff);
  server.on("/valveBack/on", handleValveBackOn);
  server.on("/valveBack/off", handleValveBackOff);
  
  server.begin();
  Serial.println("HTTP server started");
}

void loop() {
  server.handleClient();
}
