#include <Arduino.h>
#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>
#include <WiFiClient.h>

ESP8266WiFiMulti WiFiMulti;

byte incomingByte = B0000000;
byte address = B0000;
byte command = B0000;

void setup() {
  // put your setup code here, to run once:
  Serial.begin(115200);
  Serial.println();
  Serial.println();
  Serial.println();

  for (uint8_t t = 4; t > 0; t--)
  {
    Serial.printf("[SETUP] WAIT %d...\n", t);
    Serial.flush();
    delay(1000);
  }

  WiFi.mode(WIFI_STA);
  WiFiMulti.addAP("ESPap", "thereisnospoon");
}

void loop() {
  if ((WiFiMulti.run() == WL_CONNECTED))
  {
    WiFiClient client;
    HTTPClient http;
    if (Serial.available() > 0)
    {
      incomingByte = Serial.read();
      address = incomingByte >> 4;
      command = incomingByte & 00001111;
      if (address == B0000) // sensor1
      {
        if (command == B0001) //sensor1_ON
        {
          Serial.print("Turn ValveFront on...\n");
          if (http.begin(client, "http://192.168.4.1/valveFront/on")) {
            int httpCode = http.GET();
            if (httpCode > 0) {
              Serial.printf("[HTTP] GET... code: %d\n", httpCode);
              if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY) {
                String payload = http.getString();
                Serial.println(payload);
              }
            } else
            {
              Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
            }
            http.end();
          } else
          {
            Serial.printf("[HTTP} Unable to connect\n");
          }
          Serial.print("Turn Pump on...\n");
          if (http.begin(client, "http://192.168.4.1/pump/on"))
          {
            int httpCode = http.GET();
            if (httpCode > 0)
            {
              Serial.printf("[HTTP] GET... code: %d\n", httpCode);
              if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY)
              {
                String payload = http.getString();
                Serial.println(payload);
              }
            } else
            {
              Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
            }
            http.end();
          } else
          {
            Serial.printf("[HTTP} Unable to connect\n");
          }
        }
        if (command == B0000) //sensor1_OFF
        {
          Serial.print("Turn ValveFront off...\n");
          if (http.begin(client, "http://192.168.4.1/valveFront/off"))
          {
            int httpCode = http.GET();
            if (httpCode > 0)
            {
              Serial.printf("[HTTP] GET... code: %d\n", httpCode);
              if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY)
              {
                String payload = http.getString();
                Serial.println(payload);
              }
            } else
            {
              Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
            }
            http.end();
          } else
          {
            Serial.printf("[HTTP} Unable to connect\n");
          }
          Serial.print("Turn Pump off...\n");
          if (http.begin(client, "http://192.168.4.1/pump/off"))
          {
            int httpCode = http.GET();
            if (httpCode > 0) {
              Serial.printf("[HTTP] GET... code: %d\n", httpCode);
              if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY)
              {
                String payload = http.getString();
                Serial.println(payload);
              }
            } else
            {
              Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
            }
            http.end();
          } else
          {
            Serial.printf("[HTTP} Unable to connect\n");
          }
        }
      }

      if (address == B0001) // sensor2
      {
        if (command == B0001) //sensor2_ON
        {
          Serial.print("Turn ValveBack on...\n");
          if (http.begin(client, "http://192.168.4.1/valveBack/on"))
          {
            int httpCode = http.GET();
            if (httpCode > 0)
            {
              Serial.printf("[HTTP] GET... code: %d\n", httpCode);
              if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY)
              {
                String payload = http.getString();
                Serial.println(payload);
              }
            } else
            {
              Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
            }
            http.end();
          } else
          {
            Serial.printf("[HTTP} Unable to connect\n");
          }
          Serial.print("Turn Pump on...\n");
          if (http.begin(client, "http://192.168.4.1/pump/on"))
          {
            int httpCode = http.GET();
            if (httpCode > 0)
            {
              Serial.printf("[HTTP] GET... code: %d\n", httpCode);
              if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY)
              {
                String payload = http.getString();
                Serial.println(payload);
              }
            } else
            {
              Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
            }
            http.end();
          } else
          {
            Serial.printf("[HTTP} Unable to connect\n");
          }
        }
        if (command == B0000) //sensor2_OFF
        {
          Serial.print("Turn ValveBack off...\n");
          if (http.begin(client, "http://192.168.4.1/valveBack/off"))
          {
            int httpCode = http.GET();
            if (httpCode > 0)
            {
              Serial.printf("[HTTP] GET... code: %d\n", httpCode);
              if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY)
              {
                String payload = http.getString();
                Serial.println(payload);
              }
            } else
            {
              Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
            }
            http.end();
          } else
          {
            Serial.printf("[HTTP} Unable to connect\n");
          }
          Serial.print("Turn Pump off...\n");
          if (http.begin(client, "http://192.168.4.1/pump/off"))
          {
            int httpCode = http.GET();
            if (httpCode > 0)
            {
              Serial.printf("[HTTP] GET... code: %d\n", httpCode);
              if (httpCode == HTTP_CODE_OK || httpCode == HTTP_CODE_MOVED_PERMANENTLY)
              {
                String payload = http.getString();
                Serial.println(payload);
              }
            } else
            {
              Serial.printf("[HTTP] GET... failed, error: %s\n", http.errorToString(httpCode).c_str());
            }
            http.end();
          } else
          {
            Serial.printf("[HTTP} Unable to connect\n");
          }
        }
      }
    }
  }
}
