#define Sensor1_RX 10 //  PA3 of the ATtiny1614
#define Sensor2_RX 9  //  PA2 of the ATtiny1614
#define Sensor3_RX 8  //  PA1 of the ATtiny1614
#define Sensor4_RX 7  //  PB0 of the ATtiny1614
#define Sensor5_RX 6  //  PB1 of the ATtiny1614
#define Sensor6_RX 3  //  PA7 of the ATtiny1614
#define Sensor_TX 0   //  PA4 of the ATtiny1614

byte address = B0000;
byte Sensor1_Address = B0000; // 0000 is for sensor1
byte Sensor2_Address = B0001; // 1000 is for sensor2

long timeBegin = 0;
long timeDelta = 100;
long Sensor1_Result_Begin = 0;
long Sensor1_Result_End = 0;
long Sensor2_Result_Begin = 0;
long Sensor2_Result_End = 0;
long Sensor1_Thresh = 200;
long Sensor2_Thresh = 300;

long result;   //variable for the result of the tx_rx measurement.
int sample = 100;
int Sensor1_Avr=0;
int Sensor2_Avr=0;


long tx_rx(int analog_read){        
  int read_high;
  int read_low;
  int diff;
  long int sum;
  int N_samples = 100;    //Number of samples to take.  Larger number slows it down, but reduces scatter.
  sum = 0;
  for (int i = 0; i < N_samples; i++){
   digitalWrite(Sensor_TX,HIGH);              //Step the voltage high on conductor 1.
   read_high = analogRead(analog_read);        //Measure response of conductor 2.
   delayMicroseconds(100);            //Delay to reach steady state.
   digitalWrite(Sensor_TX,LOW);               //Step the voltage to zero on conductor 1.
   read_low = analogRead(analog_read);         //Measure response of conductor 2.
   diff = read_high - read_low;       //desired answer is the difference between high and low.
 sum += diff;                       //Sums up N_samples of these measurements.
 }
  return sum;
}                         //End of tx_rx function.

long normalize(int sensor_RX){
  long sum=0;
  long avr=0;
  for(long i = 0 ; i < sample ; i++)
  {
    sum = sum + tx_rx(sensor_RX);
  }
  avr = sum/sample;
  return avr;
}
  
void setup() {
  pinMode(Sensor_TX,OUTPUT);      //Pin 2 provides the voltage step
  Serial.begin(115200);
  Sensor1_Avr = normalize(Sensor1_RX);
  Sensor2_Avr = normalize(Sensor2_RX);
}

void loop() {
  
  long Sensor1_Result = (tx_rx(Sensor1_RX)-Sensor1_Avr);
  long Sensor2_Result = (tx_rx(Sensor2_RX)-Sensor2_Avr);
  long timeCurrent = millis();
  
  if (timeBegin + timeDelta < timeCurrent) {
    
    // This here is run only after each timeDelta 
    Sensor1_Result_End = Sensor1_Result;
    if (Sensor1_Result_End - Sensor1_Result_Begin > Sensor1_Thresh) {
      sendMessage(Sensor1_Address,B0001); //on
    }
    if (Sensor1_Result_Begin - Sensor1_Result_End > Sensor1_Thresh) {
      sendMessage(Sensor1_Address,B0000); //off
    }

    // Reset value
    Sensor1_Result_Begin = Sensor1_Result_End;

    /////
    // This here is run only after each timeDelta 
    Sensor2_Result_End = Sensor2_Result;
    if (Sensor2_Result_End - Sensor2_Result_Begin > Sensor2_Thresh) {
      sendMessage(Sensor2_Address,B0001); //on
    }
    if (Sensor2_Result_Begin - Sensor2_Result_End > Sensor2_Thresh) {
      sendMessage(Sensor2_Address,B0000); //off
    }

    // Reset value
    Sensor2_Result_Begin = Sensor2_Result_End;

    // Reset timer
    timeBegin = timeCurrent;
  }
  
//  delay(500);
}

void sendMessage(byte address, byte command) {
    byte message = B00000000;
    message = (address << 4) | command;
//    Serial.println(message,BIN);
    Serial.write(message);
  }
